%global codename fuerte
%global shortname visualization

Name:		ros-%{codename}-visualization
Version:	1.8.9
Release:	2%{?dist}
Summary:	Visualization tools for ROS
License:	BSD and wxWidgets and CC-BY
URL:		http://ros.org/wiki/visualization
Source0:	https://code.ros.org/svn/release/download/stacks/visualization/visualization-%{version}/visualization-%{version}.tar.bz2
# common_rosdeps is obsolete as of fuerte
Patch0:		ros-visualization-nocr.patch
# nvidia's cg toolkit is non-free, so we don't have it.
Patch1:		ros-visualization-nocg.patch
BuildRequires:	ros-%{codename}-ros-devel, ros-%{codename}-ros-comm-devel
BuildRequires:	ros-%{codename}-geometry-devel, ros-%{codename}-common-msgs-devel
BuildRequires:	ros-%{codename}-pluginlib-devel, ros-%{codename}-image-common-devel
BuildRequires:	ros-%{codename}-laser-pipeline-devel, ros-%{codename}-python-qt-binding
BuildRequires:	ros-%{codename}-robot-model-devel, ros-%{codename}-visualization-common-devel
BuildRequires:	ros-rx
BuildRequires:	qt-devel, yaml-cpp-devel, assimp-devel, gtest-devel, minizip-devel
BuildRequires:	cmake, python-yaml
BuildRequires:	chrpath
Requires:	ros-rx
Provides:	ros-%{shortname} = %{version}-%{release}

%description
Visualization tools for robots.  Currently just rviz, a 3d visualization
environment for robots using ROS, as well as rxbag_plugins, which extend the 
visualization capabilities of rxbag.

%package devel
Summary:	Development files for ROS visualization
Requires:	ros-%{codename}-ros-devel, ros-%{codename}-ros-comm-devel
Requires:	ros-%{codename}-geometry-devel, ros-%{codename}-common-msgs-devel
Requires:	ros-%{codename}-pluginlib-devel, ros-%{codename}-image-common-devel
Requires:	ros-%{codename}-laser-pipeline-devel, ros-%{codename}-python-qt-binding
Requires:	ros-%{codename}-robot-model-devel, ros-%{codename}-visualization-common-devel
Requires:	qt-devel, yaml-cpp-devel, assimp-devel, gtest-devel, minizip-devel
Requires:	%{name} = %{version}-%{release}
Provides:	ros-%{shortname}-devel = %{version}-%{release}

%description devel
Development files for ROS visualization.

%prep
%setup -q -c
# We have to do this so the cmake gunk can find itself. So idiotic.
mv %{shortname}-%{version} %{shortname}
%patch0 -p1 -b .nocr
%patch1 -p1 -b .nocg

%build
cd %{shortname}
source /etc/catkin/profile.d/10.ros.all
export ROS_PACKAGE_PATH="%{_builddir}/%{name}-%{version}:$ROS_PACKAGE_PATH"
for i in interactive_markers rviz; do
  pushd $i
  mkdir build
  cd build
  %cmake -DSETUPTOOLS_DEB_LAYOUT=OFF ..
  make %{?_smp_mflags}
  popd
done

%install
cd %{shortname}
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/
cp -a *.xml %{buildroot}%{_datadir}/ros-stacks/%{shortname}/

# interactive_markers
pushd interactive_markers
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/interactive_markers/lib
cp -a include test *.xml *.dox %{buildroot}%{_datadir}/ros-stacks/%{shortname}/interactive_markers/
mkdir -p %{buildroot}%{_libdir}
cp -a lib/libinteractive_markers.so %{buildroot}%{_libdir}/libinteractive_markers.so
ln -s %{_libdir}/libinteractive_markers.so %{buildroot}%{_datadir}/ros-stacks/%{shortname}/interactive_markers/lib/libinteractive_markers.so
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/interactive_markers/src
mkdir -p %{buildroot}%{python_sitelib}
cp -a src/interactive_markers %{buildroot}%{python_sitelib}/interactive_markers
ln -s %{python_sitelib}/interactive_markers %{buildroot}%{_datadir}/ros-stacks/%{shortname}/interactive_markers/src/interactive_markers
popd

# rviz
pushd rviz
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/bin
mkdir -p %{buildroot}%{_bindir}
for i in image_view rviz send_grid_cells send_images send_lots_of_points; do
  cp -a bin/$i %{buildroot}%{_bindir}
  ln -s %{_bindir}/$i %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/bin/$i
done
cp -a CHANGES_FROM_WX_VERSION *.dox *.xml images scripts help test ogre_media %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/lib
cp -a lib/librviz_sip.exp %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/lib
for i in libdefault_plugin.so librviz_sip.so librviz.so; do
  cp -a lib/$i %{buildroot}%{_libdir}/$i
  ln -s %{_libdir}/$i %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/lib/$i
done
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/src/rviz/default_plugin/interactive_markers/
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/src/rviz/default_plugin/markers/
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/src/rviz/helpers/
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/src/rviz/image/
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/src/rviz/ogre_helpers/
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/src/rviz/properties/
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/src/rviz/robot/
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/src/rviz/selection/
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/src/rviz/tools/
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/src/rviz/view_controllers/
pushd src
for i in `find rviz | grep "\.h"`; do
  export I_BASENAME=`basename $i`
  export I_PATHNAME=`echo $i | sed "s|$I_BASENAME||g"`
  cp -a $i %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rviz/src/$I_PATHNAME
done
popd
popd

# rxbag_plugins
pushd rxbag_plugins
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rxbag_plugins/src
cp -a *.xml *.dox icons %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rxbag_plugins/
cp -a src/rxbag_plugins %{buildroot}%{python_sitelib}/rxbag_plugins
ln -s %{python_sitelib}/rxbag_plugins %{buildroot}%{_datadir}/ros-stacks/%{shortname}/rxbag_plugins/src/rxbag_plugins
popd

chrpath -d %{buildroot}%{_bindir}/* 
chrpath -d %{buildroot}%{_libdir}/*.so

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%{_bindir}/image_view
%{_bindir}/rviz
%{_bindir}/send_grid_cells
%{_bindir}/send_images
%{_bindir}/send_lots_of_points
%{_datadir}/ros-stacks/%{shortname}/
%exclude %{_datadir}/ros-stacks/%{shortname}/interactive_markers/include
%exclude %{_datadir}/ros-stacks/%{shortname}/rviz/src
%{_libdir}/libdefault_plugin.so
%{_libdir}/libinteractive_markers.so
%{_libdir}/librviz_sip.so
%{_libdir}/librviz.so
%{python_sitelib}/interactive_markers
%{python_sitelib}/rxbag_plugins

%files devel
%{_datadir}/ros-stacks/%{shortname}/interactive_markers/include
%{_datadir}/ros-stacks/%{shortname}/rviz/src

%changelog
* Tue Jun  5 2012 Tom Callaway <spot@fedoraproject.org> - 1.8.9-2
- package up rviz header files

* Mon Jun  4 2012 Tom Callaway <spot@fedoraproject.org> - 1.8.9-1
- initial package
